<script>
import setConfigs from '@gitlab/ui/dist/config';
import { GlSkeletonLoader } from '@gitlab/ui';
import HeaderMenu from './components/header.vue';
import CodeResult from './components/code_result.vue';

setConfigs();

export default {
  name: 'IndexPage',
  auth: false,
  components: {
    HeaderMenu,
    GlSkeletonLoader,
    CodeResult,
  },
  data: () => ({
    currentQuestion: '',
    currentSource: '',
    loading: false,
    testResults: null,
    questions: [],
  }),
  fetchOnServer: false,
  computed: {
    askText() {
      if (this.currentSource === 'doc') {
        return 'Ask about the product';
      } else if (this.currentSource === 'handbook') {
        return 'Ask about the handbook';
      } else if (this.currentSource === 'blog') {
        return 'Ask about the Blog';
      }
      return 'Ask anything';
    },
  },
  created: async function () {
    this.loading = true;
    this.testResults = await this.$axios.$get('/api/results');
    this.loading = false;
  },
  async mounted() {
    /*  */
  },
  methods: {
    codify: (code) => {
      return code;
    },
    askDocs: async function () {
      if (this.currentQuestion) {
        const newQuestion = {
          question: this.currentQuestion,
          loading: true,
          answer: '',
          sources: [],
        };
        this.questions.splice(0, 0, newQuestion);
        this.currentQuestion = '';

        this.loading = true;
        const result = await this.$axios.$get(
          '/api/ask?q=' + newQuestion.question + '&source=' + this.currentSource
        );
        // eslint-disable-next-line no-console
        console.log('API Result : ', result);

        this.loading = false;
        newQuestion.loading = false;
        newQuestion.error = result.name === 'Error';
        newQuestion.answer = result.msg;
        newQuestion.sources = result.sources;
      }
    },
    selectSource: function (sourceType) {
      this.currentSource = sourceType;
    },
  },
};
</script>

<template>
  <div class="">
    <div class="container gl-mt-7 gl-mb-4 gl-display-flex">
      <div>
        <h2 class="gl-mt-0">Code Suggestions Evaluation</h2>
        <p>
          <a
            href="https://gitlab.com/groups/gitlab-org/-/epics/10818"
            target="_blank"
            >Epic for evaluation/testing models</a
          >
        </p>
      </div>
    </div>

    <div
      class="gl-bg-gray-10 gl-border-gray-50 gl-border-solid gl-border-0 gl-border-t-1 gl-border-b-1 gl-pt-4 gl-pb-4"
    >
      <div class="container distributed md typography">
        <header-menu></header-menu>
      </div>
    </div>
    <div class="container distributed md typography">
      <gl-skeleton-loader v-if="loading"></gl-skeleton-loader>
      <div
        v-if="!loading && testResults"
        class="container distributed md typography"
      >
        <div
          v-for="(result, resultIndex) in testResults"
          :key="resultIndex"
          class="gl-my-6"
        >
          <h1 class="gl-my-0 gl-font-weight-bold gl-font-lg">
            {{ result.user_intention }}
          </h1>
          <div class="gl-display-flex">
            <div class="gl-flex-grow-1 gl-mr-4">
              <code-result
                :name="'Prompt for ' + result.language"
                :language="result.language"
                :source="result.prompt.join(' ')"
              ></code-result>
            </div>
            <div class="gl-flex-grow-1">
              <code-result
                name="GitLab current Code suggestions"
                :language="result.language"
                :test="result.gitlab_model"
              ></code-result>
            </div>
          </div>
          <div class="gl-display-flex">
            <div class="gl-flex-grow-1 gl-mr-4">
              <code-result
                name="Anthropic"
                :language="result.language"
                :test="result.anthropic"
              ></code-result>
            </div>
            <div class="gl-flex-grow-1">
              <code-result
                name="Anthropic Fast"
                :language="result.language"
                :test="result.anthropic_fast"
              ></code-result>
            </div>
          </div>
          <div class="gl-display-flex">
            <div class="gl-flex-grow-1 gl-mr-4">
              <code-result
                name="Vertex Combined (code-bison + gecko)"
                :language="result.language"
                :test="result.vertex_combined"
              ></code-result>
            </div>
            <div class="gl-flex-grow-1">
              <code-result
                name="Vertex Gecko"
                :language="result.language"
                :test="result.vertex_gecko"
              ></code-result>
            </div>
          </div>
          <div class="gl-display-flex">
            <div class="gl-flex-grow-1 gl-mr-4">
              <code-result
                name="Vertex Code Bison"
                :language="result.language"
                :test="result.vertex_code_bison"
              ></code-result>
            </div>
            <div class="gl-flex-grow-1">
              <code-result
                name="Vertex Text Bison"
                :language="result.language"
                :test="result.vertex_text_bison"
              ></code-result>
            </div>
          </div>
        </div>
        <hr />
      </div>
    </div>
  </div>
</template>

<style scoped></style>
